/*
 * Copyright (c) 2020, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.wso2.esb.integration.common.utils;

import java.util.ArrayList;
import java.util.List;

public class LogReaderManager {

    private List<CarbonLogReader> readerList;

    public LogReaderManager() {
        readerList = new ArrayList<>();
    }

    public void start(CarbonLogReader... readers) {
        for (int i = 0; i < readers.length; i++) {
            readerList.add(readers[i]);
            readers[i].start();
        }
    }

    public void stop(CarbonLogReader... readers) {
        for (int i = 0; i < readers.length; i++) {
            readers[i].stop();
            readerList.remove(readers[i]);
        }
    }

    public void stopAll() {
        readerList.forEach(CarbonLogReader::stop);
        readerList.clear();
    }

    public void clearAll() {
        readerList.forEach(CarbonLogReader::clearLogs);
    }
}
